package es.markse;

public abstract class TVehiculoTierra extends Simple{

	protected double COSTE_FIJO;
	protected double COSTE_POR_KILOMETRO;
	
	public TVehiculoTierra(Muelle muelleOrigen, Puerto puertoOrigen, Fecha fechaInicioTrayecto, Muelle muelleDestino, Puerto puertoDestino, Fecha fechaFinTrayecto) {
        super(muelleOrigen, puertoOrigen, fechaInicioTrayecto, muelleDestino, puertoDestino, fechaFinTrayecto);
    }
	
	/**************************************************
	 * METODOS QUE SE APLICARAN A VEHICULOS DE TIERRA * 
	 **************************************************/
	
	 /**
     * Método que calcula el coste del trayecto por camión
     * @return Coste del trayecto en euros
     */
    @Override
    protected double costeTrayecto() {
        return COSTE_FIJO + (this.distanciaKilometros * COSTE_POR_KILOMETRO);
    }
	
	/**
     * Metodo para cambiar el coste fijo de un trayecto
     * @param coste coste fijo nuevo
     * @throws IllegalArgumentException el coste no puede ser negativo
     */
    protected void cambiarCosteFijo(double coste) {
    	if(coste<0)
    		throw new IllegalArgumentException("Coste no puede ser negativo");
    	this.COSTE_FIJO = coste;
    }
    
    /**
     * Metodo para cambiar el coste por kilometro de un trayecto
     * @param coste coste por kilometro nuevo
     * @throws IllegalArgumentException el coste no puede ser negativo
     */
    protected void cambiarCostePorKilometro(double coste) {
    	if(coste<0)
    		throw new IllegalArgumentException("Coste no puede ser negativo");
    	this.COSTE_POR_KILOMETRO = coste;
    }
}
